#pragma once
#include "Entity.h"
#include "EntityStateGravity.h"
#include "EntityStateSplash.h"
#define CS_ENEMY_GOLEMPAPER_CREATENAME L"CS_enemy_golempaper"
//¾ÞÄ§£º²¼
class CS_Enemy_GolemPaper :
    public Entity
{
public:
    CS_Enemy_GolemPaper();
    void Init(std::weak_ptr<Entity> self) override;
    void Step() override;
    void SetState(int stateID, int lr) override;
    void SetState(std::wstring stateName, int lr) override;
    void Attack(std::weak_ptr<Entity> dst, int* outDamage, float* outAngle, bool* outTakedown, int* outElemType, float* outShockForce, float* outHeavy) override;
    bool Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage) override;
    EntityStateGravity stateGravity;
    EntityStateSplash stateSplash;
    int stateID = 0;
    int drop_counter = 60;
    int wake_counter = 60;
    int move_counter = 0;
    int moveinterval_counter = 0;
    int act_wait = 0;
    bool bAction = false;
    float walkSound = 0;
    std::weak_ptr<Entity> target;
    float srcVx = 0;
    bool bNormalMode = false;
    void MoveOver();
};

std::shared_ptr<Entity> CreateCS_Enemy_GolemPaper();